(*
 * iocp ˸׽ַװ
 *)
unit iocp_sockets;

interface

{$I in_iocp.inc}        // ģʽ

uses
  {$IFDEF DELPHI_XE7UP}
  Winapi.Windows, System.Classes, System.SysUtils,
  Datasnap.Provider, System.Variants, System.DateUtils, {$ELSE}
  Windows, Classes, SysUtils, Provider, Variants, DateUtils, {$ENDIF}
  iocp_base, iocp_zlib, iocp_api,
  iocp_Winsock2, iocp_wsExt, iocp_utils,
  iocp_baseObjs, iocp_objPools, iocp_senders,
  iocp_receivers, iocp_msgPacks, iocp_log,
  http_objects, iocp_WsJSON;

type

  // ================== ׽  ======================

  TRawSocket = class(TObject)
  private
    FConnected: Boolean;       // Ƿ
    FErrorCode: Integer;       // 쳣
    FPeerIP: String;           // IP
    FPeerIPPort: string;       // IP+Port
    FPeerPort: Integer;        // Port
    FSocket: TSocket;          // ׽
    procedure InternalClose;    
  protected
    procedure IniSocket(AServer: TObject; ASocket: TSocket; AData: Pointer = nil); virtual;
    procedure SetPeerAddr(const Addr: PSockAddrIn);
  public
    constructor Create(AddSocket: Boolean);
    destructor Destroy; override;
    procedure Close; virtual;    
  public
    property Connected: Boolean read FConnected;
    property ErrorCode: Integer read FErrorCode;
    property PeerIP: String read FPeerIP;
    property PeerPort: Integer read FPeerPort;
    property PeerIPPort: String read FPeerIPPort;
    property Socket: TSocket read FSocket;
  public
    class function GetPeerIP(const Addr: PSockAddrIn): String;
  end;

  // ================== ׽  ======================

  TListenSocket = class(TRawSocket)
  public
    function Bind(Port: Integer; const Addr: String = ''): Boolean;
    function StartListen: Boolean;
  end;

  // ================== AcceptEx Ͷ׽ ======================

  TAcceptSocket = class(TRawSocket)
  private
    FListenSocket: TSocket;    // ׽
    FIOData: TPerIOData;       // ڴ
    FByteCount: Cardinal;      // Ͷ
  public
    constructor Create(ListenSocket: TSocket);
    destructor Destroy; override;
    function AcceptEx: Boolean; {$IFDEF USE_INLINE} inline; {$ENDIF}
    procedure NewSocket; {$IFDEF USE_INLINE} inline; {$ENDIF}
    function SetOption: Boolean; {$IFDEF USE_INLINE} inline; {$ENDIF}
  end;

  // ================== ҵִģ ======================

  TStreamSocket = class;
  TIOCPSocket   = class;
  THttpSocket   = class;
  TWebSocket    = class;

  TBaseWorker = class(TObject)
  protected
    FServer: TObject;           // TInIOCPServer 
    FGlobalLock: TThreadLock;   // ȫ
    FThreadIdx: Integer;        // 
  protected
    procedure Execute(const ASocket: TIOCPSocket); virtual; abstract;
    procedure StreamExecute(const ASocket: TStreamSocket); virtual; abstract;
    procedure HttpExecute(const ASocket: THttpSocket); virtual; abstract;
    procedure WebSocketExecute(const ASocket: TWebSocket); virtual; abstract;
  public
    property GlobalLock: TThreadLock read FGlobalLock; // ҵʱ
    property ThreadIdx: Integer read FThreadIdx;
  end;

  // ================== Socket  ======================
  // FState ״̬
  // 1.  = 0ر = 9
  // 2. ռ = 1TransmitFile ʱ +1κ쳣 +1
  //    ֵ=1,2ֵΪ쳣
  // 3. Թرգ=0TransmitFile=2ĿУֱӹر
  // 4. =0 -> ɹ

  TBaseSocket = class(TRawSocket)
  private
    FLinkNode: PLinkRec;       // Ӧͻ˳ص PLinkRec

    FRecvBuf: PPerIOData;      // õݰ
    FSender: TBaseTaskSender;  // ݷã

    FObjPool: TIOCPSocketPool; // 
    FServer: TObject;          // TInIOCPServer 
    FWorker: TBaseWorker;      // ҵִߣã

    FComplete: Boolean;        // /ҵ
    FRefCount: Integer;        // 
    FState: Integer;           // ״̬ԭӲ
    FTickCount: Cardinal;      // ͻ˷ʺ
    FUseTransObj: Boolean;     // ʹ TTransmitObject 

    FData: Pointer;            // ݣûչ

    function CheckDelayed(ATickCount: Cardinal): Boolean;
    function GetActive: Boolean; {$IFDEF USE_INLINE} inline; {$ENDIF}
    function GetBufferPool: TIODataPool; {$IFDEF USE_INLINE} inline; {$ENDIF}
    function GetReference: Boolean; {$IFDEF USE_INLINE} inline; {$ENDIF}
    function GetSocketState: Boolean; {$IFDEF USE_INLINE} inline; {$ENDIF}

    procedure InternalRecv(Complete: Boolean);
    procedure OnSendError(Sender: TObject);
  protected
    FBackground: Boolean;      // ִ̨״̬
    FByteCount: Cardinal;      // ֽ

    {$IFDEF TRANSMIT_FILE}     // TransmitFile ģʽ
    FTask: TTransmitObject;    // 
    FTaskExists: Boolean;      // 
    procedure FreeTransmitRes; // ͷ TransmitFile Դ
    procedure InterTransmit;   // 
    procedure InterFreeRes; virtual; abstract; // ͷŷԴ
    {$ENDIF}

    procedure ClearResources; virtual; abstract;
    procedure Clone(Source: TBaseSocket);  // ¡תԴ
    procedure DoWork(AWorker: TBaseWorker; ASender: TBaseTaskSender);  // ҵ̵߳
    procedure ExecuteWork; virtual; abstract;  // 
    procedure IniSocket(AServer: TObject; ASocket: TSocket; AData: Pointer = nil); override;
    procedure InterCloseSocket(Sender: TObject); virtual;
    procedure InternalPush(AData: PPerIOData); // 
    procedure MarkIODataBuf(AData: PPerIOData); virtual;
    procedure SocketError(IOKind: TIODataType); virtual;

    // ·ֹӦò㱻
    function CheckTimeOut(ANowTickCount: Cardinal): Boolean;  // ʱ
    function Lock(PushMode: Boolean): Integer;  // ǰ
    procedure ToBackground(AMaster: TBaseSocket); virtual; // Ϊ̨Դ
    procedure PostRecv; virtual;  // Ͷݽ
    procedure PostEvent(IOKind: TIODataType); virtual; abstract; // Ͷ¼
    procedure TryClose;  // Թر
  public
    constructor Create(AObjPool: TIOCPSocketPool; ALinkNode: PLinkRec); virtual;
    destructor Destroy; override;
    procedure Close; override;  // ر
  public
    property Active: Boolean read GetActive;
    property Background: Boolean read FBackground;  // ִ̨ģʽ
    property BufferPool: TIODataPool read GetBufferPool;
    property Complete: Boolean read FComplete;
    property LinkNode: PLinkRec read FLinkNode;
    property ObjPool: TIOCPSocketPool read FObjPool;
    property RecvBuf: PPerIOData read FRecvBuf;
    property Reference: Boolean read GetReference;
    property Sender: TBaseTaskSender read FSender;
    property SocketState: Boolean read GetSocketState;
    property Worker: TBaseWorker read FWorker;
  public
    //  Dataûչ
    property Data: Pointer read FData write FData;
  end;

  TBaseSocketClass = class of TBaseSocket;

  // ================== ԭʼ Socket ==================

  TStreamSocket = class(TBaseSocket)
  private
    FClientId: TNameString;    // ͻ id
    FRole: TClientRole;        // Ȩ
  protected
    {$IFDEF TRANSMIT_FILE}
    procedure InterFreeRes; override;
    {$ENDIF}
    procedure ClearResources; override;
    procedure ExecuteWork; override;
    procedure IniSocket(AServer: TObject; ASocket: TSocket; AData: Pointer = nil); override;
    procedure PostEvent(IOKind: TIODataType); override; 
  public
    procedure SendData(const Data: PAnsiChar; Size: Cardinal); overload; virtual;
    procedure SendData(const Msg: String); overload; virtual;
    procedure SendData(Handle: THandle); overload; virtual;
    procedure SendData(Stream: TStream); overload; virtual;
    procedure SendDataVar(Data: Variant); virtual;
  public
    property ByteCount: Cardinal read FByteCount;
    property ClientId: TNameString read FClientId write FClientId;
    property Role: TClientRole read FRole write FRole;  // ɫ/Ȩ
  end;

  // ================== C/S ģʽҵ ==================

  // 1. ˽յ

  TReceiveParams = class(TReceivePack)
  private
    FSocket: TIOCPSocket;     // 
    FMsgHead: PMsgHead;       // Эͷλ
    function GetLogName: string;
  protected
    procedure SetUniqueMsgId;
  public
    constructor Create(AOwner: TIOCPSocket); overload;
    procedure CreateAttachment(const ALocalPath: string); override;
  public
    property LogName: string read GetLogName;
    property MsgHead: PMsgHead read FMsgHead;
    property Socket: TIOCPSocket read FSocket;
  end;

  // 2. ͻ˵

  TReturnResult = class(TBaseMessage)
  private
    FSocket: TIOCPSocket;     // 
    FSender: TBaseTaskSender; // 
  public
    constructor Create(AOwner: TIOCPSocket; AInitialize: Boolean = True);
    procedure LoadFromFile(const AFileName: String; ServerMode: Boolean = False); override;
    procedure LoadFromVariant(const AProviders: array of TDataSetProvider;
                              const ATableNames: array of String); overload; override;
  public
    property Socket: TIOCPSocket read FSocket;
    // Эͷ
    property Action: TActionType read FAction;
    property ActResult: TActionResult read FActResult write FActResult;
    property Offset: TFileSize read FOffset;
    property OffsetEnd: TFileSize read FOffsetEnd;
  end;

  TIOCPSocket = class(TBaseSocket)
  private
    FReceiver: TServerReceiver;// ݽ
    FParams: TReceiveParams;   // յϢ
    FResult: TReturnResult;    // ص
    FEnvir: PEnvironmentVar;   // Ϣ
    FAction: TActionType;      // ڲ¼
    FSessionId: Cardinal;      // Իƾ֤ id

    function CheckMsgHead(InBuf: PAnsiChar): Boolean;
    function CreateSession: Cardinal;
    function GetRole: TClientRole;
    function GetLogName: string;
    function SessionValid(ASession: Cardinal): Boolean;

    procedure CreateResources;
    procedure HandleDataPack;
    procedure ReturnHead(ActResult: TActionResult);
    procedure ReturnMessage(ActResult: TActionResult; const ErrMsg: String = '');
    procedure ReturnResult;
    procedure SetLogoutState;
  protected
    {$IFDEF TRANSMIT_FILE}
    procedure InterFreeRes; override;
    {$ENDIF}
    procedure ClearResources; override;
    procedure ExecuteWork; override;  // 
    procedure IniSocket(AServer: TObject; ASocket: TSocket; AData: Pointer = nil); override;
    procedure InterCloseSocket(Sender: TObject); override;
    procedure PostEvent(IOKind: TIODataType); override;
    procedure SocketError(IOKind: TIODataType); override;
    procedure ToBackground(AMaster: TBaseSocket); override;
  public
    destructor Destroy; override;
  public
    // ҵģ
    procedure SetLogState(AEnvir: PEnvironmentVar);
  public
    property Action: TActionType read FAction;
    property Envir: PEnvironmentVar read FEnvir;
    property LoginName: string read GetLogName;
    property Params: TReceiveParams read FParams;
    property Result: TReturnResult read FResult;
    property Role: TClientRole read GetRole;  // ɫ/Ȩ    
    property SessionId: Cardinal read FSessionId;
  end;

  // ================== Http Э Socket ==================

  TRequestObject = class(THttpRequest);

  TResponeObject = class(THttpRespone);

  THttpSocket = class(TBaseSocket)
  private
    FRequest: THttpRequest;    // http 
    FRespone: THttpRespone;    // http Ӧ
    FStream: TFileStream;      // ļ
    FKeepAlive: Boolean;       // 
    FSessionId: AnsiString;    // Session Id
    procedure UpgradeSocket(SocketPool: TIOCPSocketPool);
    procedure DecodeHttpRequest;
  protected
    {$IFDEF TRANSMIT_FILE}
    procedure InterFreeRes; override;
    {$ENDIF}
    procedure ClearResources; override;
    procedure ExecuteWork; override;
    procedure PostEvent(IOKind: TIODataType); override;  // Ͷ¼
    procedure SocketError(IOKind: TIODataType); override;
  public
    destructor Destroy; override;
    // ļ
    procedure CreateStream(const FileName: String);
    procedure WriteStream(Data: PAnsiChar; DataLength: Integer);
    procedure CloseStream;
  public
    property Request: THttpRequest read FRequest;
    property Respone: THttpRespone read FRespone;
    property SessionId: AnsiString read FSessionId;
  end;

  // ================== WebSocket  ==================

  // . ص JSON Ϣ
  
  TResultJSON = class(TSendJSON)
  public
    property DataSet;
  end;
  
  TWebSocket = class(TStreamSocket)
  private
    FReceiver: TWSServerReceiver;  // ݽ
    FJSON: TBaseJSON;          // յ JSON 
    FResult: TResultJSON;      // Ҫص JSON 
    FMsgType: TWSMsgType;      // 
    FOpCode: TWSOpCode;        // WebSocket 
    FRole: TClientRole;        // ͻȨޣԤ裩
    FUserName: TNameString;    // ûƣԤ裩
  protected
    FData: PAnsiChar;          // յλ
    FMsgSize: UInt64;          // ǰϢյۼƳ
    FFrameSize: UInt64;        // ǰ֡
    FFrameRecvSize: UInt64;    // յݳ
    procedure SetProps(AOpCode: TWSOpCode; AMsgType: TWSMsgType;
                       AData: Pointer; AFrameSize: Int64; ARecvSize: Cardinal);
  protected
    procedure ClearOwnerMark;
    procedure ClearResources; override;
    procedure ExecuteWork; override;
    procedure InternalPing;
    procedure PostEvent(IOKind: TIODataType); override;
    procedure ToBackground(AMaster: TBaseSocket); override;
  public
    constructor Create(AObjPool: TIOCPSocketPool; ALinkNode: PLinkRec); override;
    destructor Destroy; override;

    procedure SendData(const Data: PAnsiChar; Size: Cardinal); overload; override;
    procedure SendData(const Msg: String); overload; override;
    procedure SendData(Handle: THandle); overload; override;
    procedure SendData(Stream: TStream); overload; override;
    procedure SendDataVar(Data: Variant); override;

    procedure SendResult(UTF8CharSet: Boolean = False);
  public
    property Data: PAnsiChar read FData;  // raw
    property FrameRecvSize: UInt64 read FFrameRecvSize; // raw
    property FrameSize: UInt64 read FFrameSize; // raw
    property MsgSize: UInt64 read FMsgSize; // raw

    property JSON: TBaseJSON read FJSON; // JSON
    property Result: TResultJSON read FResult; // JSON
  public
    property MsgType: TWSMsgType read FMsgType; // 
    property OpCode: TWSOpCode read FOpCode;  // WebSocket 
  public
    property Role: TClientRole read FRole write FRole;
    property UserName: TNameString read FUserName write FUserName;
  end;

  // ================== TSocketBroker ׽ ==================

  TSocketBroker = class;

  TAcceptBroker = procedure(Sender: TSocketBroker; const Host: AnsiString;
                            Port: Integer; var Accept: Boolean) of object;

  TBindIPEvent  = procedure(Sender: TSocketBroker; const Data: PAnsiChar;
                            DataSize: Cardinal) of object;

  TOuterPingEvent = TBindIPEvent;

  TSocketBroker = class(TBaseSocket)
  private
    FAction: Integer;          // ʼ
    FBroker: TObject;          // 
    FCmdConnect: Boolean;      // HTTP ģʽ

    FDualBuf: PPerIOData;      // ׽ֵĽڴ
    FDualConnected: Boolean;   // ׽״̬
    FDualSocket: TSocket;      // ׽

    FRecvState: Integer;       // ״̬
    FSocketType: TSocketBrokerType;  // 
    FTargetHost: AnsiString;   // ַ
    FTargetPort: Integer;      // ķ˿

    FOnBind: TBindIPEvent;     // ¼

    // µͶŷ 
    procedure BrokerPostRecv(ASocket: TSocket; AData: PPerIOData; ACheckState: Boolean = True);
    // HTTP Эİ
    procedure HttpBindOuter(Connection: TSocketBroker; const Data: PAnsiChar; DataSize: Cardinal);
  protected
    FBrokerId: AnsiString;     // ķ Id
    procedure ClearResources; override;
    procedure ExecuteWork; override;
    procedure IniSocket(AServer: TObject; ASocket: TSocket; AData: Pointer = nil); override;
    procedure InterCloseSocket(Sender: TObject); override;
    procedure MarkIODataBuf(AData: PPerIOData); override;
    procedure PostEvent(IOKind: TIODataType); override; // Ͷ¼ɾܾ񡢳ʱ        
  protected
    procedure AssociateInner(InnerBroker: TSocketBroker);
    procedure SendInnerFlag;
    procedure SetConnection(AServer: TObject; Connection: TSocket);
  public
    procedure CreateBroker(const AServer: AnsiString; APort: Integer);  // м
  end;

implementation

uses
  iocp_server, http_base, http_utils, iocp_threads, iocp_managers;

type
  THeadMessage   = class(TBaseMessage);
  TIOCPBrokerRef = class(TInIOCPBroker);

{ TRawSocket }

procedure TRawSocket.Close;
begin
  if FConnected then
    InternalClose;  // ر
end;

constructor TRawSocket.Create(AddSocket: Boolean);
begin
  inherited Create;
  if AddSocket then  // һ Socket
    IniSocket(nil, iocp_utils.CreateSocket);
end;

destructor TRawSocket.Destroy;
begin
  if FConnected then
    InternalClose; // ر
  inherited;
end;

class function TRawSocket.GetPeerIP(const Addr: PSockAddrIn): String;
begin
  // ȡIP
  Result := iocp_Winsock2.inet_ntoa(Addr^.sin_addr);
end;

procedure TRawSocket.IniSocket(AServer: TObject; ASocket: TSocket; AData: Pointer);
begin
  //  Socket
  FSocket := ASocket;
  FConnected := FSocket <> INVALID_SOCKET;
end;

procedure TRawSocket.InternalClose;
begin
  // ر Socket
  try
    iocp_Winsock2.Shutdown(FSocket, SD_BOTH);
    iocp_Winsock2.CloseSocket(FSocket);
    FSocket := INVALID_SOCKET;
  finally
    FConnected := False;
  end;
end;

procedure TRawSocket.SetPeerAddr(const Addr: PSockAddrIn);
begin
  // ӵַϢȡ IPPort
  FPeerIP := iocp_Winsock2.inet_ntoa(Addr^.sin_addr);
  FPeerPort := Addr^.sin_port;
  FPeerIPPort := FPeerIP + ':' + IntToStr(FPeerPort);
end;

{ TListenSocket }

function TListenSocket.Bind(Port: Integer; const Addr: String): Boolean;
var
  SockAddr: TSockAddrIn;
begin
  // 󶨵ַ
  // htonl(INADDR_ANY); κεַϼ
  FillChar(SockAddr, SizeOf(TSockAddr), 0);

  SockAddr.sin_family := AF_INET;
  SockAddr.sin_port := htons(Port);
  SockAddr.sin_addr.S_addr := inet_addr(PAnsiChar(ResolveHostIP(Addr)));

  if (iocp_Winsock2.bind(FSocket, TSockAddr(SockAddr), SizeOf(TSockAddr)) <> 0) then
  begin
    Result := False;
    FErrorCode := WSAGetLastError;
    iocp_log.WriteLog('TListenSocket.Bind->Error:' + IntToStr(FErrorCode));
  end else
  begin
    Result := True;
    FErrorCode := 0;
  end;
end;

function TListenSocket.StartListen: Boolean;
begin
  // 
  if (iocp_Winsock2.listen(FSocket, MaxInt) <> 0) then
  begin
    Result := False;
    FErrorCode := WSAGetLastError;
    iocp_log.WriteLog('TListenSocket.StartListen->Error:' + IntToStr(FErrorCode));
  end else
  begin
    Result := True;
    FErrorCode := 0;
  end;
end;

{ TAcceptSocket }

function TAcceptSocket.AcceptEx: Boolean;
begin
  // Ͷ AcceptEx 
  FillChar(FIOData.Overlapped, SizeOf(TOverlapped), 0);

  FIOData.Owner := Self;       // 
  FIOData.IOType := ioAccept;  // 
  FByteCount := 0;

  Result := gAcceptEx(FListenSocket, FSocket,
                      Pointer(FIOData.Data.buf), 0,   //  0ȴһ
                      ADDRESS_SIZE_16, ADDRESS_SIZE_16,
                      FByteCount, @FIOData.Overlapped);

  if Result then
    FErrorCode := 0
  else begin
    FErrorCode := WSAGetLastError;
    Result := FErrorCode = WSA_IO_PENDING;
    if (Result = False) then
      iocp_log.WriteLog('TAcceptSocket.AcceptEx->Error:' + IntToStr(FErrorCode));
  end;
end;

constructor TAcceptSocket.Create(ListenSocket: TSocket);
begin
  inherited Create(True);
  // ½ AcceptEx õ Socket
  FListenSocket := ListenSocket;
  GetMem(FIOData.Data.buf, ADDRESS_SIZE_16 * 2);  // һڴ
  FIOData.Data.len := ADDRESS_SIZE_16 * 2;
  FIOData.Node := nil;  // 
end;

destructor TAcceptSocket.Destroy;
begin
  FreeMem(FIOData.Data.buf);  // ͷڴ
  inherited;
end;

procedure TAcceptSocket.NewSocket;
begin
  // ½ Socket
  FSocket := iocp_utils.CreateSocket;
end;

function TAcceptSocket.SetOption: Boolean;
begin
  //  FListenSocket Ե FSocket
  Result := iocp_Winsock2.setsockopt(FSocket, SOL_SOCKET,
                 SO_UPDATE_ACCEPT_CONTEXT, PAnsiChar(@FListenSocket),
                 SizeOf(TSocket)) <> SOCKET_ERROR;
end;

{ TBaseSocket }

constructor TBaseSocket.Create(AObjPool: TIOCPSocketPool; ALinkNode: PLinkRec);
begin
  inherited Create(False);
  // FSocket ɿͻ˽ʱ
  //   TInIOCPServer.AcceptClient
  //       TIOCPSocketPool.CreateObjData
  FObjPool := AObjPool;
  FLinkNode := ALinkNode;
  FUseTransObj := True;  
end;

function TBaseSocket.CheckDelayed(ATickCount: Cardinal): Boolean;
begin
  // ȡʱĲ
  if (ATickCount >= FTickCount) then
    Result := ATickCount - FTickCount <= 3000
  else
    Result := High(Cardinal) - ATickCount + FTickCount <= 3000;
  {$IFDEF TRANSMIT_FILE}
  if Assigned(FTask) then  // TransmitFile û
    Result := Result and (FTask.Exists = False);
  {$ENDIF}
end;

function TBaseSocket.CheckTimeOut(ANowTickCount: Cardinal): Boolean;
  function GetTickCountDiff: Boolean;
  begin
    if (ANowTickCount >= FTickCount) then
      Result := ANowTickCount - FTickCount >= TInIOCPServer(FServer).TimeOut
    else
      Result := High(Cardinal) - FTickCount + ANowTickCount >= TInIOCPServer(FServer).TimeOut;
  end;
begin
  // ʱ
  if (FTickCount = NEW_TICKCOUNT) then  // ͶżϿTBaseSocket.SetSocket
  begin
    Inc(FByteCount);  // ByteCount +
    Result := (FByteCount >= 5);  // 
  end else
    Result := GetTickCountDiff;
end;

procedure TBaseSocket.Clone(Source: TBaseSocket);
begin
  // 任 Source ׽ֵԴתƵ¶
  //  TIOCPSocketPool ãֹΪʱ

  // ת Source ׽ַ֡
  IniSocket(Source.FServer, Source.FSocket, Source.FData);

  FPeerIP := Source.FPeerIP;
  FPeerPort := Source.FPeerPort;
  FPeerIPPort := Source.FPeerIPPort;

  //  Source Դֵ
  // Source.FServer 䣬ͷʱҪ飺TBaseSocket.Destroy
  Source.FData := nil;
  
  Source.FPeerIP := '';
  Source.FPeerPort := 0;
  Source.FPeerIPPort := '';

  Source.FConnected := False;
  Source.FSocket := INVALID_SOCKET;
   
  // δ FTask  
end;

procedure TBaseSocket.Close;
begin
  // رգڽֹʱ
  ClearResources;  // ֻԴͷţ´β½
  inherited;
end;

destructor TBaseSocket.Destroy;
begin
  {$IFDEF TRANSMIT_FILE}
  if Assigned(FTask) then
    FTask.Free;
  {$ENDIF}
  if TInIOCPServer(FServer).Active and Assigned(FRecvBuf) then
  begin
    BufferPool.Push(FRecvBuf^.Node);  // ڴ
    FRecvBuf := Nil;
  end;
  inherited;
end;

procedure TBaseSocket.DoWork(AWorker: TBaseWorker; ASender: TBaseTaskSender);
begin
  // ʼ
  //  FWorkerFSender Ϊ Nil

  {$IFDEF TRANSMIT_FILE}
  if FUseTransObj then
  begin
    if (Assigned(FTask) = False) then
    begin
      FTask := TTransmitObject.Create(Self); // TransmitFile 
      FTask.OnError := OnSendError;
    end;
    FTask.Socket := FSocket;
    FTaskExists := False; // 
  end;
  {$ENDIF}
  
  FErrorCode := 0;      // 쳣
  FByteCount := FRecvBuf^.Overlapped.InternalHigh;  // յֽ

  FWorker := AWorker;   // ִ
  FSender := ASender;   // 

  FSender.Owner := Self;
  FSender.Socket := FSocket;
  FSender.OnError := OnSendError;

  // ִ
  ExecuteWork;
    
end;

{$IFDEF TRANSMIT_FILE}
procedure TBaseSocket.FreeTransmitRes;
begin
  // ̵߳ãTransmitFile 
  if (InterlockedDecrement(FState) = 1) then  // FState=2 -> 쳣
    InterFreeRes // ʵ֣ʽͷŷԴжǷͶ WSARecv
  else
    InterCloseSocket(Self);
end;
{$ENDIF}

function TBaseSocket.GetActive: Boolean;
begin
  // ǰȡʼ״̬չݣ
  Result := (iocp_api.InterlockedCompareExchange(Integer(FByteCount), 0, 0) > 0);
end;

function TBaseSocket.GetBufferPool: TIODataPool;
begin
  // ȡڴ
  Result := TInIOCPServer(FServer).IODataPool;
end;

function TBaseSocket.GetReference: Boolean;
begin
  // ʱãҵ FRecvBuf^.RefCount
  Result := InterlockedIncrement(FRefCount) = 1;
end;

function TBaseSocket.GetSocketState: Boolean;
begin
  // ȡ״̬, FState = 1 ˵
  Result := iocp_api.InterlockedCompareExchange(FState, 1, 1) = 1;
end;

procedure TBaseSocket.InternalPush(AData: PPerIOData);
var
  ByteCount, Flags: Cardinal;
begin
  // Ϣ̵߳ã
  //  ADataTPushMessage.FPushBuf

  // صṹ
  FillChar(AData^.Overlapped, SizeOf(TOverlapped), 0);

  FErrorCode := 0;
  FRefCount := 0;  // AData:Socket = 1:n
  FTickCount := GetTickCount;  // +

  ByteCount := 0;
  Flags := 0;

  if (InterlockedDecrement(FState) <> 0) then
    InterCloseSocket(Self)
  else
    if (iocp_Winsock2.WSASend(FSocket, @(AData^.Data), 1, ByteCount,
        Flags, LPWSAOVERLAPPED(@AData^.Overlapped), nil) = SOCKET_ERROR) then
    begin
      FErrorCode := WSAGetLastError;
      if (FErrorCode <> ERROR_IO_PENDING) then  // 쳣
      begin
        SocketError(AData^.IOType);
        InterCloseSocket(Self);  // ر
      end else
        FErrorCode := 0;
    end;

end;

procedure TBaseSocket.InternalRecv(Complete: Boolean);
var
  ByteCount, Flags: DWORD;
begin
  // ύһ

  // δɣ̳ʱʱ䣨⹥
  if (Complete = False) and (TInIOCPServer(FServer).TimeOut > 0) then
    Dec(FTickCount, 10000);

  // صṹ
  FillChar(FRecvBuf^.Overlapped, SizeOf(TOverlapped), 0);

  FRecvBuf^.Owner := Self;  // 
  FRecvBuf^.IOType := ioReceive;  // iocp_server ж
  FRecvBuf^.Data.len := IO_BUFFER_SIZE; // ָ

  ByteCount := 0;
  Flags := 0;

  // ʱ FState=1κֵ˵쳣
  // FState-FState <> 0 -> 쳣ı״̬رգ

  if (InterlockedDecrement(FState) <> 0) then
    InterCloseSocket(Self)
  else  // FRecvBuf^.Overlapped  TPerIOData ַͬ
    if (iocp_Winsock2.WSARecv(FSocket, @(FRecvBuf^.Data), 1, ByteCount,
        Flags, LPWSAOVERLAPPED(@FRecvBuf^.Overlapped), nil) = SOCKET_ERROR) then
    begin
      FErrorCode := WSAGetLastError;
      if (FErrorCode <> ERROR_IO_PENDING) then  // 쳣
      begin
        SocketError(ioReceive);
        InterCloseSocket(Self);  // ر
      end else
        FErrorCode := 0;
    end;

  // Ͷɣ FByteCount > 0, ԽϢ, ͬʱעⳬʱ
  //   CheckTimeOutTPushThread.DoMethodTIOCPSocketPool.GetSockets
  if (FByteCount = 0) then
    FByteCount := 1;  // ̫󣬷ʱ

  //   
  if (FComplete <> Complete) then
    FComplete := Complete;
    
end;

function TBaseSocket.Lock(PushMode: Boolean): Integer;
const
  SOCKET_STATE_IDLE  = 0;  // 
  SOCKET_STATE_BUSY  = 1;  // 
  SOCKET_STATE_TRANS = 2;  // TransmitFile  
begin
  // ǰ
  //  ״̬ FState = 0 -> 1, ϴ -> ɹ
  //  Ժ Socket ڲκ쳣 FState+
  case iocp_api.InterlockedCompareExchange(FState, 1, 0) of  // ԭֵ

    SOCKET_STATE_IDLE: begin
      if PushMode then   // ģʽ
      begin
        if FComplete then
          Result := SOCKET_LOCK_OK
        else
          Result := SOCKET_LOCK_FAIL;
      end else
      begin
        // ҵ߳ģʽTWorkThread.HandleIOData
        Result := SOCKET_LOCK_OK;     // 
      end;
      if (Result = SOCKET_LOCK_FAIL) then // ҵδɣ
        if (InterlockedDecrement(FState) <> 0) then
          InterCloseSocket(Self);
    end;

    SOCKET_STATE_BUSY:
      Result := SOCKET_LOCK_FAIL;     // 

    SOCKET_STATE_TRANS:
      if FUseTransObj then
        Result := SOCKET_LOCK_FAIL    // 
      else
        Result := SOCKET_LOCK_CLOSE;  // 쳣

    else
      Result := SOCKET_LOCK_CLOSE;    // ѹرջ쳣
  end;
end;

procedure TBaseSocket.MarkIODataBuf(AData: PPerIOData);
begin
  // 
end;

procedure TBaseSocket.IniSocket(AServer: TObject; ASocket: TSocket; AData: Pointer);
begin
  inherited;

  FServer := AServer;// ǰ
  FData := AData;    // չ

  // ڴ飨ͷʱգ
  if (FRecvBuf = nil) then
  Begin
    FRecvBuf := BufferPool.Pop^.Data; //  FServer ֵ
    FRecvBuf^.IOType := ioReceive;  // 
    FRecvBuf^.Owner := Self;  // 
  End;

  FByteCount := 0;   // ݳ
  FComplete := True; // ȴ
  FErrorCode := 0;   // 쳣
  FState := 9;       // Ч״̬Ͷ Recv ʽʹ

  // ֵֹΪʱ
  //   TTimeoutThread.ExecuteWork
  FTickCount := NEW_TICKCOUNT;
end;

procedure TBaseSocket.InterCloseSocket(Sender: TObject);
begin
  // ڲر
  InterlockedExchange(Integer(FByteCount), 0); // 
  InterlockedExchange(FState, 9);  // Ч״̬
  TInIOCPServer(FServer).CloseSocket(Self);  // ùر̣߳ظرգ
end;

{$IFDEF TRANSMIT_FILE}
procedure TBaseSocket.InterTransmit;
begin
  if FTask.Exists then
  begin
    FTaskExists := True;
    InterlockedIncrement(FState);  // FState+ʱ=2
    FTask.TransmitFile;
  end;
end;
{$ENDIF}

procedure TBaseSocket.OnSendError(Sender: TObject);
begin
  // 쳣Ļص
  //   TBaseSocket.DoWorkTBaseTaskObject.Send...
  FErrorCode := TBaseTaskObject(Sender).ErrorCode;
  InterlockedIncrement(FState);  // FState+
  SocketError(TBaseTaskObject(Sender).IOType);
end;

procedure TBaseSocket.PostRecv;
begin
  // ʱͶŽջ
  //   TInIOCPServer.AcceptClientTHttpSocket.ExecuteWork
  FState := 1;  // 跱æ
  InternalRecv(True); // Ͷʱ FState-
end;

procedure TBaseSocket.SocketError(IOKind: TIODataType);
const
  PROCEDURE_NAMES: array[ioReceive..ioTimeOut] of string = (
                   'Post WSARecv->', 'Post WSASend->',
                   {$IFDEF TRANSMIT_FILE} 'TransmitFile->', {$ENDIF}
                   'InternalPush->', 'InternalPush->',
                   'InternalPush->');
begin
  // д쳣־
  if Assigned(FWorker) then  // ʹͶţû FWorker
    iocp_log.WriteLog(PROCEDURE_NAMES[IOKind] + PeerIPPort +
                      ',Error:' + IntToStr(FErrorCode) +
                      ',BusiThread:' + IntToStr(FWorker.ThreadIdx));
end;

procedure TBaseSocket.ToBackground(AMaster: TBaseSocket);
begin
  // Empty
end;

procedure TBaseSocket.TryClose;
begin
  // Թر
  // FState+, ԭֵ: 0,2,3... <> 1 -> ر
  if (InterlockedIncrement(FState) in [1, 3]) then // <> 2
    InterCloseSocket(Self);
end;

{ TStreamSocket }

procedure TStreamSocket.ClearResources;
begin
  {$IFDEF TRANSMIT_FILE}
  if Assigned(FTask) then
    FTask.FreeResources(True);
  {$ENDIF}
end;

procedure TStreamSocket.ExecuteWork;
begin
  try
    FTickCount := GetTickCount;
    FWorker.StreamExecute(Self);  // °ùִ
  finally
    {$IFDEF TRANSMIT_FILE}
    if (FTaskExists = False) then {$ENDIF}
      InternalRecv(True);  // 
  end;
end;

procedure TStreamSocket.IniSocket(AServer: TObject; ASocket: TSocket;
  AData: Pointer);
begin
  inherited;
  FClientId := '';
  FRole := crUnknown;
end;

procedure TStreamSocket.PostEvent(IOKind: TIODataType);
begin
  // Empty
end;

{$IFDEF TRANSMIT_FILE}
procedure TStreamSocket.InterFreeRes;
begin
  // ͷ TransmitFile ķԴͶŽգ
  try
    ClearResources;
  finally
    InternalRecv(True);
  end;
end;
{$ENDIF}

procedure TStreamSocket.SendData(const Data: PAnsiChar; Size: Cardinal);
var
  Buf: PAnsiChar;
begin
  // ڴݣ Data
  if Assigned(Data) and (Size > 0) then
  begin
    GetMem(Buf, Size);
    System.Move(Data^, Buf^, Size);
    {$IFDEF TRANSMIT_FILE}
    FTask.SetTask(Buf, Size);
    InterTransmit;
    {$ELSE}
    FSender.Send(Buf, Size);
    {$ENDIF}
  end;
end;

procedure TStreamSocket.SendData(const Msg: String);
begin
  // ı
  if (Msg <> '') then
  begin
    {$IFDEF TRANSMIT_FILE}
    FTask.SetTask(Msg);
    InterTransmit;
    {$ELSE}
    FSender.Send(Msg);
    {$ENDIF}
  end;
end;

procedure TStreamSocket.SendData(Handle: THandle);
begin
  // ļ handleԶرգ
  if (Handle > 0) and (Handle <> INVALID_HANDLE_VALUE) then
  begin
    {$IFDEF TRANSMIT_FILE}
    FTask.SetTask(Handle, GetFileSize64(Handle));
    InterTransmit;
    {$ELSE}
    FSender.Send(Handle, GetFileSize64(Handle));
    {$ENDIF}
  end;
end;

procedure TStreamSocket.SendData(Stream: TStream);
begin
  // ݣԶͷţ
  if Assigned(Stream) then
  begin
    {$IFDEF TRANSMIT_FILE}
    FTask.SetTask(Stream, Stream.Size);
    InterTransmit;
    {$ELSE}
    FSender.Send(Stream, Stream.Size, True);
    {$ENDIF}
  end;
end;

procedure TStreamSocket.SendDataVar(Data: Variant);
begin
  // Ϳɱ
  if (VarIsNull(Data) = False) then
  begin
    {$IFDEF TRANSMIT_FILE}
    FTask.SetTaskVar(Data);
    InterTransmit;
    {$ELSE}
    FSender.SendVar(Data);
    {$ENDIF}
  end;
end;

{ TReceiveParams }

constructor TReceiveParams.Create(AOwner: TIOCPSocket);
begin
  inherited Create;
  FSocket := AOwner;
end;

procedure TReceiveParams.CreateAttachment(const ALocalPath: string);
begin
  // ļո
  inherited;
  if Error then  // ִ
  begin
    FSocket.FResult.ActResult := arFail;
    FSocket.FResult.Msg := GetSysErrorMessage();
  end else
  begin
    FSocket.FAction := atAfterReceive; // ʱִ¼
    FSocket.FResult.FActResult := arAccept;  // ϴ
    FSocket.FReceiver.Complete := False;  // ո
    
    // ضļϢ
    if (FAction in FILE_CHUNK_ACTIONS) then
    begin
      FSocket.FResult.FOffset := FOffset;  // Ҫ½գFOffset ޸
      FSocket.FResult.SetFileName(ExtractFileName(Attachment.FileName));  // ļͬʱı
      FSocket.FResult.SetDirectory(EncryptString(ExtractFilePath(Attachment.FileName))); // ܷļ
      FSocket.FResult.SetAttachFileName(GetAttachFileName);  // ͻ˵ļȫ
    end;

    //  URL·ӦÿԹ
    if Assigned(TInIOCPServer(FSocket.FServer).HttpDataProvider) then
      SetURL(ChangeSlash(Attachment.FileName));
  end;
end;

function TReceiveParams.GetLogName: string;
begin
  // ȡ¼ʱ
  Result := FSocket.GetLogName;
end;

procedure TReceiveParams.SetUniqueMsgId;
begin
  // Ϣ MsgId
  //   Ϣ÷Ψһ MsgId
  //   ޸Ļ MsgId
  //   Ҫ FResult.FMsgIdͻ˰ѷͷϢ
  FMsgHead^.MsgId := TSystemGlobalLock.GetMsgId;
end;

{ TReturnResult }

constructor TReturnResult.Create(AOwner: TIOCPSocket; AInitialize: Boolean);
begin
  inherited Create(nil);  // ýյ Owner
  FSocket := AOwner;
  PeerIPPort := FSocket.PeerIPPort;
  if AInitialize then
  begin
    FOwner := AOwner.Params.FOwner;
    SetHeadMsg(AOwner.Params.FMsgHead, True);
  end;
end;

procedure TReturnResult.LoadFromFile(const AFileName: String; ServerMode: Boolean);
begin
  inherited;  // ̴ļȴ
  if Error then
  begin
    FActResult := arFail;
    FOffset := 0;
    FOffsetEnd := 0;
  end else
  begin
    FActResult := arOK;
    if (FAction = atFileDownChunk) then  // ϵ
    begin
      FOffset := FSocket.FParams.FOffset;  // λ
      AdjustTransmitRange(FSocket.FParams.FOffsetEnd);  // , =ͻ FMaxChunkSize
      SetDirectory(EncryptString(ExtractFilePath(AFileName)));  // ؼܵ·
    end;
  end;
end;

procedure TReturnResult.LoadFromVariant(const AProviders: array of TDataSetProvider;
  const ATableNames: array of String);
begin
  inherited; // ֱӵ
end;

{ TIOCPSocket }

function TIOCPSocket.CheckMsgHead(InBuf: PAnsiChar): Boolean;
  function CheckLogState: TActionResult;
  begin
    // ¼״̬
    if (FParams.Action = atUserLogin) then
      Result := arOK       // ͨ
    else
    if (FParams.SessionId = 0) then
      Result := arErrUser  // ͻȱ SessionId, Ƿû
    else
    if (FParams.SessionId = INI_SESSION_ID) or
       (FParams.SessionId = FSessionId) then
      Result := arOK       // ͨ
    else
    if SessionValid(FParams.SessionId) then
      Result := arOK       // ͨ
    else
      Result := arOutDate; // ƾ֤
  end;
begin
  // һݰЧԡû¼״̬ http Э飩

  if (FByteCount < IOCP_SOCKET_SIZE) or  // ̫
     (MatchSocketType(InBuf, IOCP_SOCKET_FLAG) = False) then // C/S ־
  begin
    // رշ
    InterCloseSocket(Self);
    Result := False;
  end else
  begin
    // 
    Result := True;
    FAction := atUnknown;  // ڲ¼ڸ䣩
    FResult.FSender := FSender;

    // ȸЭͷ
    FParams.FMsgHead := PMsgHead(InBuf + IOCP_SOCKET_FLEN); // ʱ
    FParams.SetHeadMsg(FParams.FMsgHead);
    FResult.SetHeadMsg(FParams.FMsgHead, True);

    if (FParams.Action = atUnknown) then  // 1. Ӧ
      FReceiver.Complete := True
    else begin
      // 2. ¼״̬
      if Assigned(TInIOCPServer(FServer).ClientManager) then
        FResult.ActResult := CheckLogState
      else begin // ¼
        FResult.ActResult := arOK;
        if (FParams.FSessionId = INI_SESSION_ID) then
          FResult.FSessionId := CreateSession;
      end;
      if (FResult.ActResult in [arOffline, arOutDate]) then
        FReceiver.Complete := True  // 3. 
      else // 4. ׼
        FReceiver.Prepare(InBuf, FByteCount);
    end;
  end;
end;

procedure TIOCPSocket.ClearResources;
begin
  // Դ
  if Assigned(FResult) then
    FReceiver.Clear;
  if Assigned(FParams) then
    FParams.Clear;
  if Assigned(FResult) then
    FResult.Clear;
  SetLogoutState;     // ǳ
  {$IFDEF TRANSMIT_FILE}
  if Assigned(FTask) then  
    FTask.FreeResources(False);  //  FResult.Clear ͷ
  {$ENDIF}
end;

procedure TIOCPSocket.CreateResources;
begin
  // Դա/ݽ
  if (FReceiver = nil) then
  begin
    FParams := TReceiveParams.Create(Self);  // ǰ
    FResult := TReturnResult.Create(Self, False);
    FReceiver := TServerReceiver.Create(FParams); // ں
  end else
  if FReceiver.Complete then
  begin
    FParams.Clear;
    FResult.Clear;
  end;
end;

function TIOCPSocket.CreateSession: Cardinal;
var
  NowTime: TDateTime;
  Certify: TCertifyNumber;
  LHour, LMinute, LSecond, LMilliSecond: Word;
begin
  // һ¼ƾ֤ЧΪ SESSION_TIMEOUT 
  //   ṹ( + Ч) xor 
  NowTime := Now();

  DecodeTime(NowTime, LHour, LMinute, LSecond, LMilliSecond);

  Certify.DayCount := Trunc(NowTime - 43000);  // 
  Certify.Timeout := LHour * 60 + LMinute + SESSION_TIMEOUT;

  if (Certify.Timeout >= 1440) then  // һķ
  begin
    Inc(Certify.DayCount);  // һ
    Dec(Certify.Timeout, 1440);
  end;

  Result := Certify.Session xor Cardinal($AB12);
end;

destructor TIOCPSocket.Destroy;
begin
  // ͷԴ
  if Assigned(FReceiver) then
  begin
    FReceiver.Free;
    FReceiver := Nil;
  end;
  if Assigned(FParams) then
  begin
    FParams.Free;
    FParams := Nil;
  end;
  if Assigned(FResult) then
  begin
    FResult.Free;
    FResult := Nil;
  end;
  inherited;
end;

procedure TIOCPSocket.ExecuteWork;
const
  IO_FIRST_PACKET = True;  // ݰ
  IO_SUBSEQUENCE  = False; // ݰ
begin
  // ݿ FRecvBuf 

  {$IFNDEF DELPHI_7}
  {$REGION '+ '}
  {$ENDIF}

  // 1 Դ
  CreateResources;

  // 1.1 
  FTickCount := GetTickCount;

  case FReceiver.Complete of
    IO_FIRST_PACKET:  // 1.2 ݰЧ  û¼״̬
      if (CheckMsgHead(FRecvBuf^.Data.buf) = False) then
        Exit;
    IO_SUBSEQUENCE:   // 1.3 պݰ
      FReceiver.Receive(FRecvBuf^.Data.buf, FByteCount);
  end;

  // 1.4 򸽼ϾӦò
  FComplete := FReceiver.Complete and (FReceiver.Cancel = False);

  {$IFNDEF DELPHI_7}
  {$ENDREGION}

  {$REGION '+ Ӧò'}
  {$ENDIF}

  // 2. Ӧò
  try
    if FComplete then   // ϡļЭ
      if FReceiver.CheckPassed then // Уɹ
        HandleDataPack  // 2.1 ҵ
      else
        ReturnMessage(arErrHash);  // 2.2 У󣬷
  finally
    // 2.3 Ͷ WSARecvݣ
    {$IFDEF TRANSMIT_FILE}
    // ܷɹǰ
    if (FTaskExists = False) then {$ENDIF}
      InternalRecv(FComplete);
  end;

  {$IFNDEF DELPHI_7}
  {$ENDREGION}
  {$ENDIF}

end;

function TIOCPSocket.GetLogName: string;
begin
  if Assigned(FEnvir) then
    Result := FEnvir^.BaseInf.Name
  else
    Result := '';
end;

function TIOCPSocket.GetRole: TClientRole;
begin
  if Assigned(FEnvir) then
    Result := Envir^.BaseInf.Role
  else
    Result := crUnknown;
end;

procedure TIOCPSocket.HandleDataPack;
begin
  // ִпͻ

  // 1. Ӧ -> ֱӷЭͷ
  if (FParams.Action = atUnknown) then
    ReturnHead(arOK)
  else

  // 2. δ¼˲رգԻ -> Эͷ
  if (FResult.ActResult in [arErrUser, arOutDate]) then
    ReturnMessage(FResult.ActResult)
  else

  // 3. 쳣
  if FParams.Error then
    ReturnMessage(arErrAnalyse)
  else begin

    // 4. Ӧòִ
    try
      FWorker.Execute(Self);
    except
      on E: Exception do  // 4.1 쳣 -> 
      begin
        ReturnMessage(arErrWork, E.Message);
        Exit;  // 4.2 
      end;
    end;

    try
      // 5. + -> 
      FReceiver.OwnerClear;

      // 6. ǷûҪر
      if (FResult.ActResult = arErrUser) then
        InterlockedIncrement(FState);  // FState+

      // 7. ͽ
      ReturnResult;

      {$IFNDEF TRANSMIT_FILE}
      // 7.1 ¼δرգ
      if Assigned(FResult.Attachment) then
      begin
        FAction := atAfterSend;
        FWorker.Execute(Self);
      end;
      {$ENDIF}
    finally
      {$IFNDEF TRANSMIT_FILE}
      if (FReceiver.Complete = False) then  // δ
        FAction := atAfterReceive;  // ָ
      if Assigned(FResult.Attachment) then
        FResult.Clear;
      {$ENDIF}
    end;

  end;

end;

procedure TIOCPSocket.IniSocket(AServer: TObject; ASocket: TSocket; AData: Pointer);
begin
  inherited;
  FSessionId := INI_SESSION_ID; // ʼƾ֤
end;

procedure TIOCPSocket.InterCloseSocket(Sender: TObject);
begin
  // ûƣ OnDisconnect ʹ
  if Assigned(FParams) then
  begin
    if (FParams.FAction <> atUserLogout) then
      FResult.FAction := atDisconnect;
    if Assigned(FEnvir) then
      FResult.UserName := FEnvir^.BaseInf.Name;
  end;
  inherited;
end;

{$IFDEF TRANSMIT_FILE}
procedure TIOCPSocket.InterFreeRes;
begin
  // ͷ TransmitFile ķԴ
  try
    try
      if Assigned(FResult.Attachment) then  // 
      begin
        FAction := atAfterSend;
        FWorker.Execute(Self);
      end;
    finally
      if (FReceiver.Complete = False) then  // δ
        FAction := atAfterReceive;  // ָ
      FResult.NilStreams(True);     // ͷŷԴ
      FTask.FreeResources(False);   // False -> ͷ
    end;
  finally  // Ͷ Recv
    InternalRecv(FComplete);
  end;
end;
{$ENDIF}

procedure TIOCPSocket.PostEvent(IOKind: TIODataType);
var
  Msg: TPushMessage;
begin
  // Ͷ¼ɾܾ񡢳ʱ    
  // 졢һЭͷϢԼ
  //   C/S  IOKind ֻ ioDeleteioRefuseioTimeOut
  //  ϢãPush(ATarget: TBaseSocket; UseUniqueMsgId: Boolean);
  //  ͬʱ HTTP ʱ THttpSocket  arRefuseδתԴ

  // 3 ڻȡʱ
  if (IOKind = ioTimeOut) and CheckDelayed(GetTickCount) then
    Exit;

  Msg := TPushMessage.Create(Self, IOKind, IOCP_SOCKET_SIZE);

  case IOKind of
    ioDelete:
      THeadMessage.CreateHead(Msg.PushBuf^.Data.buf, arDeleted);
    ioRefuse: 
      THeadMessage.CreateHead(Msg.PushBuf^.Data.buf, arRefuse);
    ioTimeOut:
      THeadMessage.CreateHead(Msg.PushBuf^.Data.buf, arTimeOut);
  end;

  // б߳
  TInIOCPServer(FServer).PushManager.AddWork(Msg);
end;

procedure TIOCPSocket.SetLogoutState;
begin
  // õǳ״̬
  FSessionId := INI_SESSION_ID;
  if Assigned(FEnvir) then
    if FEnvir^.ReuseSession then  // ӶϿ FData ҪϢ
    begin
      FEnvir^.BaseInf.Socket := 0;
      FEnvir^.BaseInf.LogoutTime := Now();
    end else
      try  // ͷŵ¼Ϣ
        TInIOCPServer(FServer).ClientManager.RemoveClient(FEnvir^.BaseInf.Name);
      finally
        FEnvir := Nil;
      end;
end;

procedure TIOCPSocket.ReturnHead(ActResult: TActionResult);
begin
  // ЭͷͻˣӦϢ
  //   ʽIOCP_HEAD_FLAG + TMsgHead

  // ЭͷϢ
  FResult.FDataSize := 0;
  FResult.FAttachSize := 0;
  FResult.FActResult := ActResult;

  if (FResult.FAction = atUnknown) then  // Ӧ
    FResult.FVarCount := FObjPool.UsedCount // ؿͻ
  else
    FResult.FVarCount := 0;

  // ֱд FSender ķͻ
  FResult.LoadHead(FSender.Data);

  // 
  FSender.SendBuffers;
end;

procedure TIOCPSocket.ReturnMessage(ActResult: TActionResult; const ErrMsg: String);
begin
  // Эͷͻ

  FParams.Clear;
  FResult.Clear;
  
  if (ErrMsg <> '') then
  begin
    FResult.Msg := ErrMsg;
    FResult.ActResult := ActResult;
    ReturnResult;
  end else
    ReturnHead(ActResult);

  case ActResult of
    arOffline:
      iocp_log.WriteLog(Self.ClassName + '->ͻδ¼.');
    arOutDate:
      iocp_log.WriteLog(Self.ClassName + '->ƾ֤/֤.');
    arErrAnalyse:
      iocp_log.WriteLog(Self.ClassName + '->쳣.');
    arErrHash:
      iocp_log.WriteLog(Self.ClassName + '->У쳣');
    arErrWork:
      iocp_log.WriteLog(Self.ClassName + '->ִ쳣, ' + ErrMsg);
  end;

end;

procedure TIOCPSocket.ReturnResult;
  procedure SendMsgHeader;
  begin
    // Эͷ
    FResult.LoadHead(FSender.Data);
    FSender.SendBuffers;
  end;
  procedure SendMsgEntity;
  begin
    // 
    {$IFDEF TRANSMIT_FILE}
    // 
    FTask.SetTask(FResult.FMain, FResult.FDataSize);
    {$ELSE}
    FSender.Send(FResult.FMain, FResult.FDataSize, False);  // رԴ
    {$ENDIF}
  end;
  procedure SendMsgAttachment;
  begin
    // ͸
    {$IFDEF TRANSMIT_FILE}
    // ø
    if (FResult.FAction = atFileDownChunk) then
      FTask.SetTask(FResult.FAttachment, FResult.FAttachSize,
                    FResult.FOffset, FResult.FOffsetEnd)
    else
      FTask.SetTask(FResult.FAttachment, FResult.FAttachSize);
    {$ELSE}
    if (FResult.FAction = atFileDownChunk) then  // رԴ
      FSender.Send(FResult.FAttachment, FResult.FAttachSize,
                   FResult.FOffset, FResult.FOffsetEnd, False)
    else
      FSender.Send(FResult.FAttachment, FResult.FAttachSize, False);
    {$ENDIF}
  end;
begin
  // ͽͻˣֱӷ
  //   TIOCPDocumentҪãͷ
  //   TIOCPSocket.HandleDataPack; TClientParams.InternalSend

  // FSender.SocketOwner Ѿ

  try
    // 1. ׼
    FResult.CreateStreams;

    if (FResult.Error = False) then
    begin
      // 2. Эͷ
      SendMsgHeader;

      // 3. ݣڴ
      if (FResult.FDataSize > 0) then
        SendMsgEntity;

      // 4. ͸
      if (FResult.FAttachSize > 0) then
        SendMsgAttachment;
    end;
  finally
    {$IFDEF TRANSMIT_FILE}
    InterTransmit;
    {$ELSE}
    NilStreams(False);  // 5. գݲͷŸ
    {$ENDIF}
  end;

end;

procedure TIOCPSocket.SocketError(IOKind: TIODataType);
begin
  // շ쳣
  if (IOKind in [ioDelete, ioPush, ioRefuse]) then  // 
    FResult.ActResult := arErrPush;
  inherited;
end;

procedure TIOCPSocket.ToBackground(AMaster: TBaseSocket);
begin
  //
end;

procedure TIOCPSocket.SetLogState(AEnvir: PEnvironmentVar);
begin
  // õ¼/ǳϢ
  if (AEnvir = nil) then  // ǳ
  begin
    SetLogoutState;
    FResult.FSessionId := FSessionId;
    FResult.ActResult := arLogout;  //  arOffline
    if Assigned(FEnvir) then  //  Socket
      FEnvir := nil;
  end else
  begin
    FSessionId := CreateSession;  // ؽԻ
    FResult.FSessionId := FSessionId;
    FResult.ActResult := arOK;
    FEnvir := AEnvir;
  end;
end;

function TIOCPSocket.SessionValid(ASession: Cardinal): Boolean;
var
  NowTime: TDateTime;
  Certify: TCertifyNumber;
  LHour, LMinute, LSecond, LMilliSecond: Word;  
begin
  // ƾ֤Ƿȷûʱ
  //   ṹ( + Ч) xor 
  NowTime := Now();

  DecodeTime(NowTime, LHour, LMinute, LSecond, LMilliSecond);

  LMinute := LHour * 60 + LMinute;  // ʱ
  LSecond :=  Trunc(NowTime - 43000);  // ʱ
  Certify.Session := ASession xor Cardinal($AB12);

  Result := (Certify.DayCount = LSecond) and (Certify.Timeout > LMinute) or
            (Certify.DayCount = LSecond + 1) and (Certify.Timeout > (1440 - LMinute));

  if Result then
    FSessionId := Certify.Session;
end;

{ THttpSocket }

procedure THttpSocket.ClearResources;
begin
  // Դ
  CloseStream;
  if Assigned(FRequest) then
    FRequest.Clear;
  if Assigned(FRespone) then
    FRespone.Clear;
  {$IFDEF TRANSMIT_FILE}
  if Assigned(FTask) then  
    FTask.FreeResources(False);  //  FResult.Clear ͷ
  {$ENDIF}    
end;

procedure THttpSocket.CloseStream;
begin
  if Assigned(FStream) then
  begin
    FStream.Free;
    FStream := Nil;
  end;
end;

procedure THttpSocket.CreateStream(const FileName: String);
begin
  // ļ
  FStream := TFileStream.Create(FileName, fmCreate or fmOpenWrite);
end;

procedure THttpSocket.DecodeHttpRequest;
begin
  // 루ݰ
  //   ҵ߳̽ FRequestFResponeӿٶ
  if (FRequest = nil) then
  begin
    FRequest := THttpRequest.Create(TInIOCPServer(FServer).HttpDataProvider, Self); // http 
    FRespone := THttpRespone.Create(TInIOCPServer(FServer).HttpDataProvider, Self); // http Ӧ
  end;
  // ʱ䡢HTTP 
  FTickCount := GetTickCount;
  TRequestObject(FRequest).Decode(FSender, FRespone, FRecvBuf);
end;

destructor THttpSocket.Destroy;
begin
  CloseStream;
  if Assigned(FRequest) then
  begin
    FRequest.Free;
    FRequest := Nil;
  end;
  if Assigned(FRespone) then
  begin
    FRespone.Free;
    FRespone := Nil;
  end;
  inherited;
end;

procedure THttpSocket.ExecuteWork;
begin
  // ִ Http 
  try
    // 1. ʹ C/S ЭʱҪתΪ TIOCPSocket
    if (FTickCount = NEW_TICKCOUNT) and (FByteCount = IOCP_SOCKET_FLEN) and
      MatchSocketType(FRecvBuf^.Data.Buf, IOCP_SOCKET_FLAG) then
    begin
      UpgradeSocket(TInIOCPServer(FServer).IOCPSocketPool);
      Exit;  // 
    end;

    // 2. Ƿṩ HTTP 
    if (Assigned(TInIOCPServer(FServer).HttpDataProvider) = False) then
    begin
      InterCloseSocket(Self);
      Exit;
    end;

    // 2. 
    DecodeHttpRequest;

    // 3.  WebSocket
    if (FRequest.UpgradeState > 0) then
    begin
      if FRequest.Accepted then  // Ϊ WebSocketܷ THttpSocket 
      begin
        TResponeObject(FRespone).Upgrade;
        UpgradeSocket(TInIOCPServer(FServer).WebSocketPool);
      end else  // ر
        InterCloseSocket(Self);
      Exit;     // 
    end;

    // 4. ִҵ
    FComplete := FRequest.Complete;   // Ƿ
    FSessionId := FRespone.SessionId; // SendWork ʱᱻɾ
    FRespone.StatusCode := FRequest.StatusCode;

    if FComplete and FRequest.Accepted and (FRequest.StatusCode < 400) then
      FWorker.HttpExecute(Self);

    // 5. ǷҪ
    if FRequest.Attacked then // 
      FKeepAlive := False
    else
      if FComplete or (FRespone.StatusCode >= 400) then  // ϻ쳣
      begin
        // Ƿ񱣴
        FKeepAlive := FRespone.KeepAlive;

        // 6. ݸͻ
        TResponeObject(FRespone).SendWork;

        if {$IFNDEF TRANSMIT_FILE} FKeepAlive {$ELSE}
           (FTaskExists = False) {$ENDIF} then // 7. Դ׼´
          ClearResources;
      end else
        FKeepAlive := True;   // δɣܹر

    // 8. ͶŻر
    if FKeepAlive and (FErrorCode = 0) then  // Ͷ
    begin
      {$IFDEF TRANSMIT_FILE}
      if (FTaskExists = False) then {$ENDIF}
        InternalRecv(FComplete);
    end else
      InterCloseSocket(Self);  // رʱԴ
                 
  except
    // 󲢷ʱڴϵ㣬Ƿ쳣
    iocp_log.WriteLog('THttpSocket.ExecuteHttpWork->' + GetSysErrorMessage);
    InterCloseSocket(Self);  // ϵͳ쳣
  end;

end;

{$IFDEF TRANSMIT_FILE}
procedure THttpSocket.InterFreeRes;
begin
  // ϣͷ TransmitFile ķԴ
  try
    ClearResources;
  finally
    if FKeepAlive and (FErrorCode = 0) then  // Ͷ
      InternalRecv(True)
    else
      InterCloseSocket(Self);
  end;
end;
{$ENDIF}

procedure THttpSocket.PostEvent(IOKind: TIODataType);
const
  REQUEST_NOT_ACCEPTABLE = HTTP_VER + ' 406 Not Acceptable';
        REQUEST_TIME_OUT = HTTP_VER + ' 408 Request Time-out';
var
  Msg: TPushMessage;
  ResponeMsg: AnsiString;
begin
  // 졢һϢͷԼ
  //   HTTP ֻ arRefusearTimeOut

  // TransmitFile  3 ڻȡʱ
  if (IOKind = ioTimeOut) and CheckDelayed(GetTickCount) then
    Exit;

  if (IOKind = ioRefuse) then
    ResponeMsg := REQUEST_NOT_ACCEPTABLE + STR_CRLF +
                  'Server: ' + HTTP_SERVER_NAME + STR_CRLF +
                  'Date: ' + GetHttpGMTDateTime + STR_CRLF +
                  'Content-Length: 0' + STR_CRLF +
                  'Connection: Close' + STR_CRLF2
  else
    ResponeMsg := REQUEST_TIME_OUT + STR_CRLF +
                  'Server: ' + HTTP_SERVER_NAME + STR_CRLF +
                  'Date: ' + GetHttpGMTDateTime + STR_CRLF +
                  'Content-Length: 0' + STR_CRLF +
                  'Connection: Close' + STR_CRLF2;

  Msg := TPushMessage.Create(Self, IOKind, Length(ResponeMsg));

  System.Move(ResponeMsg[1], Msg.PushBuf^.Data.buf^, Msg.PushBuf^.Data.len);

  // б߳
  TInIOCPServer(FServer).PushManager.AddWork(Msg);

end;

procedure THttpSocket.SocketError(IOKind: TIODataType);
begin
  // շ쳣
  if Assigned(FRespone) then      // ʱ = Nil
    FRespone.StatusCode := 500;   // 500: Internal Server Error
  inherited;
end;

procedure THttpSocket.UpgradeSocket(SocketPool: TIOCPSocketPool);
var
  oSocket: TBaseSocket;
begin
  //  THttpSocket תΪ TIOCPSocketTWebSocket
  try
    oSocket := TBaseSocket(SocketPool.Clone(Self));  // δ FTask
    oSocket.PostRecv;  // Ͷ
  finally
    InterCloseSocket(Self);  // ر
  end;
end;

procedure THttpSocket.WriteStream(Data: PAnsiChar; DataLength: Integer);
begin
  // ݵļ
  if Assigned(FStream) then
    FStream.Write(Data^, DataLength);
end;

{ TWebSocket }

procedure TWebSocket.ClearOwnerMark;
var
  p: PAnsiChar;
begin
  // 롢=0
  FReceiver.ClearMark(FData, @FRecvBuf^.Overlapped);
  if (FMsgType = mtJSON) then  //  Owner,  Ϊ 0ʾˣ
  begin
    p := FData;
    Inc(p, Length(INIOCP_JSON_FLAG));
    if SearchInBuffer(p, FRecvBuf^.Overlapped.InternalHigh, '"__MSG_OWNER":') then // ִСд
      while (p^ <> AnsiChar(',')) do
      begin
        p^ := AnsiChar('0');
        Inc(p);
      end;
  end;
end;

procedure TWebSocket.ClearResources;
begin
  if Assigned(FReceiver) then
    FReceiver.Clear;
end;

constructor TWebSocket.Create(AObjPool: TIOCPSocketPool; ALinkNode: PLinkRec);
begin
  inherited;
  FUseTransObj := False;  //  TransmitFile
  FJSON := TBaseJSON.Create(Self);
  FResult := TResultJSON.Create(Self);
  FResult.FServerMode := True;  // ģʽ
  FReceiver := TWSServerReceiver.Create(Self, FJSON);
end;

destructor TWebSocket.Destroy;
begin
  FJSON.Free;
  FResult.Free;
  FReceiver.Free;
  inherited;
end;

procedure TWebSocket.ExecuteWork;
begin
  // ݣִ

  // 1. 
  FTickCount := GetTickCount;

  if FReceiver.Complete then  // ݰ
  begin
    // 
    // ܸı FMsgType FReceiver.UnMarkData
    FMsgType := mtDefault;
    FReceiver.Prepare(FRecvBuf^.Data.buf, FByteCount);
    case FReceiver.OpCode of
      ocClose: begin
        InterCloseSocket(Self);  // رգ
        Exit;
      end;
      ocPing, ocPong: begin
        InternalRecv(True);  // Ͷţ
        Exit;
      end;
    end;
  end else
  begin
    // պݰ
    FReceiver.Receive(FRecvBuf^.Data.buf, FByteCount);
  end;

  // Ƿ
  FComplete := FReceiver.Complete;

  // 2. Ӧò
  // 2.1 ׼ÿһμ
  // 2.2 չĲ JSON ϢϲŽ

  try
    if (FMsgType = mtDefault) or FComplete then
    begin
      if (FMsgType <> mtDefault) then
        FResult.Action := FJSON.Action;  //  Action
      FWorker.WebSocketExecute(Self);
    end;
  finally
    if FComplete then   // 
    begin
      case FMsgType of
        mtJSON: begin   // չ JSON
          FJSON.Clear;  //  Attachment
          FResult.Clear;
          FReceiver.Clear;
        end;
        mtAttachment: begin  // չĸ
          FJSON.Close;  // رո
          FResult.Clear;
          FReceiver.Clear;
        end;
      end;
      // ping ͻ
      InternalPing;  
    end;
    // 
    InternalRecv(FComplete);
  end;

end;

procedure TWebSocket.InternalPing;
begin
  // Ping ͻˣµϢ
  MakeFrameHeader(FSender.Data, ocPing);
  FSender.SendBuffers;
end;

procedure TWebSocket.PostEvent(IOKind: TIODataType);
begin
  // Empty
end;

procedure TWebSocket.SendData(const Msg: String);
begin
  // δװı
  if (Msg <> '') then
  begin
    FSender.OpCode := ocText;
    FSender.Send(System.AnsiToUtf8(Msg));
  end;
end;

procedure TWebSocket.SendData(const Data: PAnsiChar; Size: Cardinal);
var
  Buf: PAnsiChar;
begin
  // δװڴݣ Data
  if Assigned(Data) and (Size > 0) then
  begin
    GetMem(Buf, Size);
    System.Move(Data^, Buf^, Size);
    FSender.OpCode := ocBiary;
    FSender.Send(Buf, Size);
  end;
end;

procedure TWebSocket.SendData(Handle: THandle);
begin
  // δװļ handleԶرգ
  if (Handle > 0) and (Handle <> INVALID_HANDLE_VALUE) then
  begin
    FSender.OpCode := ocBiary;
    FSender.Send(Handle, GetFileSize64(Handle));
  end;
end;

procedure TWebSocket.SendData(Stream: TStream);
begin
  // δװݣԶͷţ
  if Assigned(Stream) then
  begin
    FSender.OpCode := ocBiary;
    FSender.Send(Stream, Stream.Size, True);
  end;
end;

procedure TWebSocket.SendDataVar(Data: Variant);
begin
  // δװͿɱ
  if (VarIsNull(Data) = False) then
  begin
    FSender.OpCode := ocBiary;
    FSender.SendVar(Data);
  end;
end;

procedure TWebSocket.SendResult(UTF8CharSet: Boolean);
begin
  //  FResult ͻˣInIOCP-JSON
  FResult.FOwner := FJSON.Owner;
  FResult.FUTF8CharSet := UTF8CharSet;
  FResult.InternalSend(FSender, False);
end;

procedure TWebSocket.SetProps(AOpCode: TWSOpCode; AMsgType: TWSMsgType;
                     AData: Pointer; AFrameSize: Int64; ARecvSize: Cardinal);
begin
  // £TWSServerReceiver.InitResources
  FMsgType := AMsgType;  // 
  FOpCode := AOpCode;  // 
  FMsgSize := 0;  // Ϣ
  FData := AData; // õַ
  FFrameSize := AFrameSize;  // ֡
  FFrameRecvSize := ARecvSize;  // յ֡
end;

procedure TWebSocket.ToBackground(AMaster: TBaseSocket);
begin
  //
end;

{ TSocketBroker }

procedure TSocketBroker.AssociateInner(InnerBroker: TSocketBroker);
begin
  // ⲿڲ Socket ѾͶ WSARecv
  try
    // תԴ
    FDualConnected := True;
    FDualSocket := InnerBroker.FSocket;
    FDualBuf := InnerBroker.FRecvBuf;
    FDualBuf^.Owner := Self;  // 
    FPeerIPPort := 'Dual:' + FPeerIPPort;
  finally
    //  InnerBroker Դֵ
    InnerBroker.FRecvBuf := nil;
    InnerBroker.FConnected := False;
    InnerBroker.FDualConnected := False;
    InnerBroker.FSocket := INVALID_SOCKET;
    InnerBroker.InterCloseSocket(InnerBroker);
  end;
end;

procedure TSocketBroker.BrokerPostRecv(ASocket: TSocket; AData: PPerIOData; ACheckState: Boolean);
var
  ByteCount, Flags: DWORD;
begin
  // Ͷ WSRecv: ASocket, AData

  // ʱ FState=1κֵ˵쳣
  // FState = 1 -> ı״̬رգ

  if ACheckState and (InterlockedDecrement(FState) <> 0) then
  begin
    FErrorCode := 9;
    InterCloseSocket(Self);
  end else
  begin
    // صṹ
    FillChar(AData^.Overlapped, SizeOf(TOverlapped), 0);

    AData^.Owner := Self;  // 
    AData^.IOType := ioReceive;  // iocp_server ж
    AData^.Data.len := IO_BUFFER_SIZE;  // 

    ByteCount := 0;
    Flags := 0;

    if (iocp_Winsock2.WSARecv(ASocket, @(AData^.Data), 1, ByteCount,
        Flags, LPWSAOVERLAPPED(@AData^.Overlapped), nil) = SOCKET_ERROR) then
    begin
      FErrorCode := WSAGetLastError;
      if (FErrorCode <> ERROR_IO_PENDING) then  // 쳣
      begin
        SocketError(ioReceive);
        InterCloseSocket(Self);  // ر
      end else
        FErrorCode := 0;
    end;
  end;
end;

procedure TSocketBroker.ClearResources;
begin
  // δӱϿⲹ
  if TInIOCPBroker(FBroker).ReverseMode and (FSocketType = stOuterSocket) then
    TIOCPBrokerRef(FBroker).IncOuterConnection;
  if FDualConnected then  // Թر
    TryClose;
end;

procedure TSocketBroker.CreateBroker(const AServer: AnsiString; APort: Integer);
begin
  // ½һڲм׽֣ܸı

  if (FDualSocket <> INVALID_SOCKET) or
     (TInIOCPServer(FServer).ServerAddr = AServer) and  // ӵ
     (TInIOCPServer(FServer).ServerPort = APort) then
    Exit;
    
  // ׽
  FDualSocket := iocp_utils.CreateSocket;

  if (ConnectSocket(FDualSocket, AServer, APort) = False) then  // 
  begin
    FErrorCode := GetLastError;
    iocp_log.WriteLog('TSocketBroker.CreateBroker:ConnectSocket->' + GetSysErrorMessage(FErrorCode));
  end else
  if TInIOCPServer(FServer).IOCPEngine.BindIoCompletionPort(FDualSocket) then  // 
  begin
    // ڴ
    if (FDualBuf = nil) then
      FDualBuf := BufferPool.Pop^.Data;

    // Ͷ FDualSocket
    BrokerPostRecv(FDualSocket, FDualBuf, False);  

    if (FErrorCode = 0) then  // 쳣
    begin
      FDualConnected := True;
      FPeerIPPort := 'Dual:' + FPeerIPPort;  // ־
      FTargetHost := AServer;
      FTargetPort := APort;
      if TInIOCPBroker(FBroker).ReverseMode then  // 
      begin
        FSocketType := stDefault;  // ı䣨رʱӣ
        TIOCPBrokerRef(FBroker).IncOuterConnection;  // ⲹ
      end;
    end;
  end else
    FErrorCode := GetLastError;

end;

procedure TSocketBroker.ExecuteWork;
  function CheckInnerSocket: Boolean;
  begin
    // ++ⲿģʽӣ
    // 1ⲿͻˣݲ InIOCP_INNER_SOCKET
    // 2ڲķͻˣݴ InIOCP_INNER_SOCKET:InnerBrokerId
    if (PInIOCPInnerSocket(FRecvBuf^.Data.buf)^ = InIOCP_INNER_SOCKET) then
    begin
      // ڲķӣ浽б TInIOCPBroker.BindBroker 
      SetString(FBrokerId, FRecvBuf^.Data.buf + Length(InIOCP_INNER_SOCKET) + 1,
                           Integer(FByteCount) - Length(InIOCP_INNER_SOCKET) - 1);
      TIOCPBrokerRef(FBroker).AddConnection(Self, FBrokerId);
      Result := True;
    end else
      Result := False;  // ⲿĿͻ
  end;
  procedure ExecSocketAction;
  begin
    // ڲӱ־ⲿ
    try
      if (TInIOCPBroker(FBroker).BrokerId = '') then  // Ĭϱ־
        FSender.Send(InIOCP_INNER_SOCKET + ':DEFAULT')
      else  // ͬʱʹ־ⲿ
        FSender.Send(InIOCP_INNER_SOCKET + ':' + UpperCase(TInIOCPBroker(FBroker).BrokerId));
    finally
      FAction := 0;
    end;
  end;
  procedure CopyForwardData(ASocket, AToSocket: TSocket; AData: PPerIOData; MaskInt: Integer);
  begin
    // ܼ򵥻ݿ飬󲢷ʱ AData ظͶ -> 995 쳣
    try
      FSender.Socket := AToSocket;  //  AToSocket
      FRecvState := FRecvState and MaskInt;  // ȥ״̬
      TServerTaskSender(FSender).CopySend(AData);  // 
    finally
      if (FErrorCode = 0) then
        BrokerPostRecv(ASocket, AData)  // Ͷ WSRecv
      else
        InterCloseSocket(Self);
    end;
  end;
  procedure ForwardData(AProxyType: TProxyType);
  begin
    if FCmdConnect then  // 1. Http Connect Ӧand (AProxyType <> ptOuter) 
    begin
      FCmdConnect := False;
      FSender.Send(HTTP_PROXY_RESPONE);
      BrokerPostRecv(FSocket, FRecvBuf);
    end else  // 2. ת
    if (FRecvState and $0001 = 1) then
      CopyForwardData(FSocket, FDualSocket, FRecvBuf, 2)
    else
      CopyForwardData(FDualSocket, FSocket, FDualBuf, 1);
  end;
begin
  // ִУ
  //   1󶨡ⲿݵ FDualSocket
  //   2Ѿʱֱӷ͵ FDualSocket

  // Ҫ TInIOCPBroker.ProxyType

  FTickCount := GetTickCount;

  case TInIOCPBroker(FBroker).ProxyType of
    ptDefault: // Ĭϴģʽ
      if (FAction > 0) then  // , SendInnerFlag
      begin
        ExecSocketAction;    // ִв
        BrokerPostRecv(FSocket, FRecvBuf);  // Ͷ
        Exit;
      end;
    ptOuter:   // ⲿģʽ
      if (FDualConnected = False) and CheckInnerSocket then  // ڲ
      begin
        BrokerPostRecv(FSocket, FRecvBuf); // Ͷ
        Exit;
      end;
  end;

  // ʼʱЭһúɾ

  try
    if Assigned(FOnBind) then  // ʼʱ FOnBind <> nil
      try
        FOnBind(Self, FRecvBuf^.Data.buf, FByteCount);  // 󶨡
      finally
        FOnBind := nil;  // ɾ¼Ժٰ󶨣
      end;
  finally
    if FDualConnected then  // ڴ
      ForwardData(TInIOCPBroker(FBroker).ProxyType)  // ת
    else
      InterCloseSocket(Self);
  end;

end;

procedure TSocketBroker.HttpBindOuter(Connection: TSocketBroker; const Data: PAnsiChar; DataSize: Cardinal);
  procedure GetConnectHost(var p: PAnsiChar);
  var
    pb: PAnsiChar;
    i: Integer;
  begin
    // ȡַCONNECT xxx:443 HTTP/1.1
    Delete(FTargetHost, 1, Length(FTargetHost));

    pb := nil;
    Inc(p, 7);  // connect

    for i := 1 to FByteCount do
    begin
      if (p^ = #32) then
        if (pb = nil) then  // ַʼ
          pb := p
        else begin  // ַжϰ汾
          SetString(FTargetHost, pb, p - pb);
          FTargetHost := Trim(FTargetHost);
          Break;
        end;
      Inc(p);
    end;
  end;
  procedure GetHttpHost(var p: PAnsiChar);
  var
    pb: PAnsiChar;
  begin
    // ȡַHOST:
    pb := nil;
    Inc(p, 4);
    repeat
      case p^ of
        ':':
          if (pb = nil) then
            pb := p + 1;
        #13: begin
          SetString(FTargetHost, pb, p - pb);
          FTargetHost := Trim(FTargetHost);
          Exit;
        end;
      end;
      Inc(p);
    until (p^ = #10);
  end;
  procedure GetUpgradeType(var p: PAnsiChar);
  var
    S: AnsiString;
    pb: PAnsiChar;
  begin
    // ȡݳȣUPGRADE: WebSocket
    pb := nil;
    Inc(p, 14);
    repeat
      case p^ of
        ':':
          pb := p + 1;
        #13: begin
          SetString(S, pb, p - pb);
          if (UpperCase(Trim(S)) = 'WEBSOCKET') then
            FSocketType := stWebSocket;
          Exit;
        end;
      end;
      Inc(p);
    until (p^ = #10);
  end;
  procedure ExtractHostPort;
  var
    i, j, k: Integer;
  begin
    //  HostPort  ־

    j := 0;
    k := 0;

    for i := 1 to Length(FTargetHost) do  // 127.0.0.1:800@DEFAULT
      case FTargetHost[i] of
        ':':
          j := i;
        '@':  // HTTP չΪ/ֹ˾־
          k := i;
      end;

    if (k > 0) then  // ־
    begin
      if (TInIOCPBroker(FBroker).ProxyType = ptOuter) then  // ⲿ
        FBrokerId := Copy(FTargetHost, k + 1, 99);
      Delete(FTargetHost, k, 99);
    end;

    if (j > 0) then  // ڲ
    begin
      TryStrToInt(Copy(FTargetHost, j + 1, 99), FTargetPort);
      Delete(FTargetHost, j, 99);
    end;
    
  end;
  procedure HttpRequestDecode;
  var
    iState: Integer;
    pE, pb, p: PAnsiChar;
  begin
    // Http Э飺ȡϢHostUpgrade

    p := FRecvBuf^.Data.buf;  // ʼλ
    pE := PAnsiChar(p + FByteCount);  // λ

    // 1HTTPConnect =443
    if http_utils.CompareBuffer(p, 'CONNECT', True) then
    begin
      FCmdConnect := True;
      GetConnectHost(p);  // p ı
      ExtractHostPort;
      Exit;
    end;

    // 2 HTTP 
    
    iState := 0;  // Ϣ״̬
    FCmdConnect := False;
    FTargetPort := 80;  // Ĭ϶˿ڣ=443
    pb := nil;

    Inc(p, 12);

    repeat
      case p^ of
        #10:  // з
          pb := p + 1;

        #13:  // س
          if (pb <> nil) then
            if (p = pb) then  // ĻسУͷ
            begin
              Inc(p, 2);
              Break;
            end else
            if (p - pb >= 15) then
            begin
              if http_utils.CompareBuffer(pb, 'HOST', True) then
              begin
                Inc(iState);
                GetHttpHost(pb);
                ExtractHostPort;
              end else
              if http_utils.CompareBuffer(pb, 'UPGRADE', True) then  // WebSocket
              begin
                Inc(iState, 2);
                GetUpgradeType(pb);
              end;
            end;
      end;

      Inc(p);
    until (p >= pE) or (iState = 3);

  end;
  procedure HttpConnectHost(const AServer: AnsiString; APort: Integer);
  begin
    // Http Э飺ӵ HOSTûʱӵָ
    if (FTargetHost <> '') and (FTargetPort > 0) then
      CreateBroker(FTargetHost, FTargetPort)
    else
    if (AServer <> '') and (APort > 0) then  // òָ
      CreateBroker(AServer, APort);
  end;
var
  Accept: Boolean;
begin
  // Http Э飺 Connect  Host

  // ȡ Host Ϣ
  HttpRequestDecode;

  // ӵ
  if (TInIOCPServer(FServer).ServerAddr = FTargetHost) and
     (TInIOCPServer(FServer).ServerPort = FTargetPort) then
    Exit;

  Accept := True;
  if Assigned(TInIOCPBroker(FBroker).OnAccept) then  // Ƿ
    TInIOCPBroker(FBroker).OnAccept(Self, FTargetHost, FTargetPort, Accept);

  if Accept then
    case TInIOCPBroker(FBroker).ProxyType of
      ptDefault:  // Ĭϴ½ӣ
        HttpConnectHost(TInIOCPBroker(FBroker).InnerServer.ServerAddr,
                        TInIOCPBroker(FBroker).InnerServer.ServerPort);
      ptOuter:    // ڲڲӳѡȡ
        TIOCPBrokerRef(FBroker).BindInnerBroker(Connection, Data, DataSize);
    end;

end;

procedure TSocketBroker.IniSocket(AServer: TObject; ASocket: TSocket; AData: Pointer);
begin
  inherited;
  FRecvState := 0;
  FTargetHost := '';
  FTargetPort := 0;
  FUseTransObj := False;  //  TransmitFile

  FCmdConnect := False;
  FDualConnected := False;  // Dual δ
  FDualSocket := INVALID_SOCKET;

  // 
  FBroker := TInIOCPServer(FServer).IOCPBroker;

  case TInIOCPBroker(FBroker).ProxyType of
    ptDefault:  // ƽ¼
      if (TInIOCPBroker(FBroker).Protocol = tpHTTP) then
        FOnBind := HttpBindOuter
      else
        FOnBind := TInIOCPBroker(FBroker).OnBind;
    ptOuter: begin
      FBrokerId := 'DEFAULT';  // Ĭϵ FBrokerId
      FOnBind := TIOCPBrokerRef(FBroker).BindInnerBroker;  // ֱԣʱ FCmdConnect Ϊ False
    end;
  end;

end;

procedure TSocketBroker.InterCloseSocket(Sender: TObject);
begin
  // ڴ顢ر DualSocket
  if TInIOCPServer(FServer).Active and Assigned(FDualBuf) then
  begin
    BufferPool.Push(FDualBuf^.Node);
    FDualBuf := nil;
  end;
  if FDualConnected then
    try
      iocp_Winsock2.Shutdown(FDualSocket, SD_BOTH);
      iocp_Winsock2.CloseSocket(FDualSocket);
    finally
      FDualSocket := INVALID_SOCKET;
      FDualConnected := False;
    end;
  inherited;
end;

procedure TSocketBroker.MarkIODataBuf(AData: PPerIOData);
begin
  // AData Ľ״̬
  if (AData = FRecvBuf) then
    FRecvState := FRecvState or $0001  // Windows.InterlockedIncrement(FRecvState)
  else
    FRecvState := FRecvState or $0002; // Windows.InterlockedExchangeAdd(FRecvState, 2);
end;

procedure TSocketBroker.PostEvent(IOKind: TIODataType);
begin
  InterCloseSocket(Self);  // ֱӹرգ TInIOCPServer.AcceptClient
end;

procedure TSocketBroker.SendInnerFlag;
begin
  // ⲿӱ־ ExecSocketAction ִ
  FAction := 1;  // 
  FState := 0;   // 
  TInIOCPServer(FServer).BusiWorkMgr.AddWork(Self);
end;

procedure TSocketBroker.SetConnection(AServer: TObject; Connection: TSocket);
begin
  // ڲⲿ
  IniSocket(AServer, Connection);
  FSocketType := stOuterSocket;  // ӵⲿ
  if (TInIOCPBroker(FBroker).Protocol = tpNone) then
    FOnBind := TInIOCPBroker(FBroker).OnBind; // 󶨹¼
end;

end.
